=begin
#Hydrogen Integration API

#The Hydrogen Integration API

OpenAPI spec version: 1.3.1
Contact: info@hydrogenplatform.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.21

=end

require 'uri'

module IntegrationApi
  class BrokerageApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Cancel an Order
    # @param nucleus_order_id nucleus_order_id
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def cancel_brokerage_order_using_put(nucleus_order_id, opts = {})
      cancel_brokerage_order_using_put_with_http_info(nucleus_order_id, opts)
      nil
    end

    # Cancel an Order
    # @param nucleus_order_id nucleus_order_id
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def cancel_brokerage_order_using_put_with_http_info(nucleus_order_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BrokerageApi.cancel_brokerage_order_using_put ...'
      end
      # verify the required parameter 'nucleus_order_id' is set
      if @api_client.config.client_side_validation && nucleus_order_id.nil?
        fail ArgumentError, "Missing the required parameter 'nucleus_order_id' when calling BrokerageApi.cancel_brokerage_order_using_put"
      end
      # resource path
      local_var_path = '/brokerage/order/{nucleus_order_id}'.sub('{' + 'nucleus_order_id' + '}', nucleus_order_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BrokerageApi#cancel_brokerage_order_using_put\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # create a Brokerage account
    # @param brokerage_account_co brokerageAccountCO
    # @param [Hash] opts the optional parameters
    # @return [BrokerageAccountVO]
    def create_brokerage_account_using_post(brokerage_account_co, opts = {})
      data, _status_code, _headers = create_brokerage_account_using_post_with_http_info(brokerage_account_co, opts)
      data
    end

    # create a Brokerage account
    # @param brokerage_account_co brokerageAccountCO
    # @param [Hash] opts the optional parameters
    # @return [Array<(BrokerageAccountVO, Fixnum, Hash)>] BrokerageAccountVO data, response status code and response headers
    def create_brokerage_account_using_post_with_http_info(brokerage_account_co, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BrokerageApi.create_brokerage_account_using_post ...'
      end
      # verify the required parameter 'brokerage_account_co' is set
      if @api_client.config.client_side_validation && brokerage_account_co.nil?
        fail ArgumentError, "Missing the required parameter 'brokerage_account_co' when calling BrokerageApi.create_brokerage_account_using_post"
      end
      # resource path
      local_var_path = '/brokerage/account'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(brokerage_account_co)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BrokerageAccountVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BrokerageApi#create_brokerage_account_using_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # create a Bank Link
    # @param brokerage_bank_link_co brokerageBankLinkCO
    # @param [Hash] opts the optional parameters
    # @return [BrokerageBankLinkVO]
    def create_brokerage_bank_link_using_post(brokerage_bank_link_co, opts = {})
      data, _status_code, _headers = create_brokerage_bank_link_using_post_with_http_info(brokerage_bank_link_co, opts)
      data
    end

    # create a Bank Link
    # @param brokerage_bank_link_co brokerageBankLinkCO
    # @param [Hash] opts the optional parameters
    # @return [Array<(BrokerageBankLinkVO, Fixnum, Hash)>] BrokerageBankLinkVO data, response status code and response headers
    def create_brokerage_bank_link_using_post_with_http_info(brokerage_bank_link_co, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BrokerageApi.create_brokerage_bank_link_using_post ...'
      end
      # verify the required parameter 'brokerage_bank_link_co' is set
      if @api_client.config.client_side_validation && brokerage_bank_link_co.nil?
        fail ArgumentError, "Missing the required parameter 'brokerage_bank_link_co' when calling BrokerageApi.create_brokerage_bank_link_using_post"
      end
      # resource path
      local_var_path = '/brokerage/bank_link'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(brokerage_bank_link_co)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BrokerageBankLinkVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BrokerageApi#create_brokerage_bank_link_using_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create a Brokerage Client
    # @param client_co clientCO
    # @param [Hash] opts the optional parameters
    # @return [BrokerageCreateClientVO]
    def create_brokerage_client_using_post(client_co, opts = {})
      data, _status_code, _headers = create_brokerage_client_using_post_with_http_info(client_co, opts)
      data
    end

    # Create a Brokerage Client
    # @param client_co clientCO
    # @param [Hash] opts the optional parameters
    # @return [Array<(BrokerageCreateClientVO, Fixnum, Hash)>] BrokerageCreateClientVO data, response status code and response headers
    def create_brokerage_client_using_post_with_http_info(client_co, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BrokerageApi.create_brokerage_client_using_post ...'
      end
      # verify the required parameter 'client_co' is set
      if @api_client.config.client_side_validation && client_co.nil?
        fail ArgumentError, "Missing the required parameter 'client_co' when calling BrokerageApi.create_brokerage_client_using_post"
      end
      # resource path
      local_var_path = '/brokerage/client'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(client_co)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BrokerageCreateClientVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BrokerageApi#create_brokerage_client_using_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create a deposit
    # @param brokerage_deposit_co brokerageDepositCO
    # @param [Hash] opts the optional parameters
    # @return [BrokerageDepositVO]
    def create_brokerage_deposit_using_post(brokerage_deposit_co, opts = {})
      data, _status_code, _headers = create_brokerage_deposit_using_post_with_http_info(brokerage_deposit_co, opts)
      data
    end

    # Create a deposit
    # @param brokerage_deposit_co brokerageDepositCO
    # @param [Hash] opts the optional parameters
    # @return [Array<(BrokerageDepositVO, Fixnum, Hash)>] BrokerageDepositVO data, response status code and response headers
    def create_brokerage_deposit_using_post_with_http_info(brokerage_deposit_co, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BrokerageApi.create_brokerage_deposit_using_post ...'
      end
      # verify the required parameter 'brokerage_deposit_co' is set
      if @api_client.config.client_side_validation && brokerage_deposit_co.nil?
        fail ArgumentError, "Missing the required parameter 'brokerage_deposit_co' when calling BrokerageApi.create_brokerage_deposit_using_post"
      end
      # resource path
      local_var_path = '/brokerage/deposit'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(brokerage_deposit_co)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BrokerageDepositVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BrokerageApi#create_brokerage_deposit_using_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create a Brokerage document
    # @param document_co documentCO
    # @param [Hash] opts the optional parameters
    # @return [BrokerageDocumentVO]
    def create_brokerage_document_using_post(document_co, opts = {})
      data, _status_code, _headers = create_brokerage_document_using_post_with_http_info(document_co, opts)
      data
    end

    # Create a Brokerage document
    # @param document_co documentCO
    # @param [Hash] opts the optional parameters
    # @return [Array<(BrokerageDocumentVO, Fixnum, Hash)>] BrokerageDocumentVO data, response status code and response headers
    def create_brokerage_document_using_post_with_http_info(document_co, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BrokerageApi.create_brokerage_document_using_post ...'
      end
      # verify the required parameter 'document_co' is set
      if @api_client.config.client_side_validation && document_co.nil?
        fail ArgumentError, "Missing the required parameter 'document_co' when calling BrokerageApi.create_brokerage_document_using_post"
      end
      # resource path
      local_var_path = '/brokerage/document'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(document_co)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BrokerageDocumentVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BrokerageApi#create_brokerage_document_using_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create an Order
    # @param brokerage_order_co brokerageOrderCO
    # @param [Hash] opts the optional parameters
    # @return [BrokerageOrderVO]
    def create_brokerage_order_using_post(brokerage_order_co, opts = {})
      data, _status_code, _headers = create_brokerage_order_using_post_with_http_info(brokerage_order_co, opts)
      data
    end

    # Create an Order
    # @param brokerage_order_co brokerageOrderCO
    # @param [Hash] opts the optional parameters
    # @return [Array<(BrokerageOrderVO, Fixnum, Hash)>] BrokerageOrderVO data, response status code and response headers
    def create_brokerage_order_using_post_with_http_info(brokerage_order_co, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BrokerageApi.create_brokerage_order_using_post ...'
      end
      # verify the required parameter 'brokerage_order_co' is set
      if @api_client.config.client_side_validation && brokerage_order_co.nil?
        fail ArgumentError, "Missing the required parameter 'brokerage_order_co' when calling BrokerageApi.create_brokerage_order_using_post"
      end
      # resource path
      local_var_path = '/brokerage/order'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(brokerage_order_co)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BrokerageOrderVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BrokerageApi#create_brokerage_order_using_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create a withdrawal
    # @param brokerage_withdrawal_co brokerageWithdrawalCO
    # @param [Hash] opts the optional parameters
    # @return [BrokerageWithdrawalVO]
    def create_brokerage_withdrawal_using_post(brokerage_withdrawal_co, opts = {})
      data, _status_code, _headers = create_brokerage_withdrawal_using_post_with_http_info(brokerage_withdrawal_co, opts)
      data
    end

    # Create a withdrawal
    # @param brokerage_withdrawal_co brokerageWithdrawalCO
    # @param [Hash] opts the optional parameters
    # @return [Array<(BrokerageWithdrawalVO, Fixnum, Hash)>] BrokerageWithdrawalVO data, response status code and response headers
    def create_brokerage_withdrawal_using_post_with_http_info(brokerage_withdrawal_co, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BrokerageApi.create_brokerage_withdrawal_using_post ...'
      end
      # verify the required parameter 'brokerage_withdrawal_co' is set
      if @api_client.config.client_side_validation && brokerage_withdrawal_co.nil?
        fail ArgumentError, "Missing the required parameter 'brokerage_withdrawal_co' when calling BrokerageApi.create_brokerage_withdrawal_using_post"
      end
      # resource path
      local_var_path = '/brokerage/withdrawal'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(brokerage_withdrawal_co)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BrokerageWithdrawalVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BrokerageApi#create_brokerage_withdrawal_using_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete a Bank Link
    # @param nucleus_bank_link_id nucleus_bank_link_id
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_brokerage_bank_link_using_delete(nucleus_bank_link_id, opts = {})
      delete_brokerage_bank_link_using_delete_with_http_info(nucleus_bank_link_id, opts)
      nil
    end

    # Delete a Bank Link
    # @param nucleus_bank_link_id nucleus_bank_link_id
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_brokerage_bank_link_using_delete_with_http_info(nucleus_bank_link_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BrokerageApi.delete_brokerage_bank_link_using_delete ...'
      end
      # verify the required parameter 'nucleus_bank_link_id' is set
      if @api_client.config.client_side_validation && nucleus_bank_link_id.nil?
        fail ArgumentError, "Missing the required parameter 'nucleus_bank_link_id' when calling BrokerageApi.delete_brokerage_bank_link_using_delete"
      end
      # resource path
      local_var_path = '/brokerage/bank_link/{nucleus_bank_link_id}'.sub('{' + 'nucleus_bank_link_id' + '}', nucleus_bank_link_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BrokerageApi#delete_brokerage_bank_link_using_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get a Brokerage account statement
    # @param end_date end_date
    # @param nucleus_account_id nucleus_account_id
    # @param start_date start_date
    # @param statement_type statement_type
    # @param [Hash] opts the optional parameters
    # @return [BrokerageStatementVO]
    def get_brokerage_account_statement_using_get(end_date, nucleus_account_id, start_date, statement_type, opts = {})
      data, _status_code, _headers = get_brokerage_account_statement_using_get_with_http_info(end_date, nucleus_account_id, start_date, statement_type, opts)
      data
    end

    # Get a Brokerage account statement
    # @param end_date end_date
    # @param nucleus_account_id nucleus_account_id
    # @param start_date start_date
    # @param statement_type statement_type
    # @param [Hash] opts the optional parameters
    # @return [Array<(BrokerageStatementVO, Fixnum, Hash)>] BrokerageStatementVO data, response status code and response headers
    def get_brokerage_account_statement_using_get_with_http_info(end_date, nucleus_account_id, start_date, statement_type, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BrokerageApi.get_brokerage_account_statement_using_get ...'
      end
      # verify the required parameter 'end_date' is set
      if @api_client.config.client_side_validation && end_date.nil?
        fail ArgumentError, "Missing the required parameter 'end_date' when calling BrokerageApi.get_brokerage_account_statement_using_get"
      end
      # verify the required parameter 'nucleus_account_id' is set
      if @api_client.config.client_side_validation && nucleus_account_id.nil?
        fail ArgumentError, "Missing the required parameter 'nucleus_account_id' when calling BrokerageApi.get_brokerage_account_statement_using_get"
      end
      # verify the required parameter 'start_date' is set
      if @api_client.config.client_side_validation && start_date.nil?
        fail ArgumentError, "Missing the required parameter 'start_date' when calling BrokerageApi.get_brokerage_account_statement_using_get"
      end
      # verify the required parameter 'statement_type' is set
      if @api_client.config.client_side_validation && statement_type.nil?
        fail ArgumentError, "Missing the required parameter 'statement_type' when calling BrokerageApi.get_brokerage_account_statement_using_get"
      end
      # resource path
      local_var_path = '/brokerage/statement/{nucleus_account_id}'.sub('{' + 'nucleus_account_id' + '}', nucleus_account_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'end_date'] = end_date
      query_params[:'start_date'] = start_date
      query_params[:'statement_type'] = statement_type

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BrokerageStatementVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BrokerageApi#get_brokerage_account_statement_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get account balance
    # @param nucleus_portfolio_id nucleus_portfolio_id
    # @param [Hash] opts the optional parameters
    # @return [BrokerageBalanceVO]
    def get_brokerage_balance_using_get(nucleus_portfolio_id, opts = {})
      data, _status_code, _headers = get_brokerage_balance_using_get_with_http_info(nucleus_portfolio_id, opts)
      data
    end

    # Get account balance
    # @param nucleus_portfolio_id nucleus_portfolio_id
    # @param [Hash] opts the optional parameters
    # @return [Array<(BrokerageBalanceVO, Fixnum, Hash)>] BrokerageBalanceVO data, response status code and response headers
    def get_brokerage_balance_using_get_with_http_info(nucleus_portfolio_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BrokerageApi.get_brokerage_balance_using_get ...'
      end
      # verify the required parameter 'nucleus_portfolio_id' is set
      if @api_client.config.client_side_validation && nucleus_portfolio_id.nil?
        fail ArgumentError, "Missing the required parameter 'nucleus_portfolio_id' when calling BrokerageApi.get_brokerage_balance_using_get"
      end
      # resource path
      local_var_path = '/brokerage/balance/{nucleus_portfolio_id}'.sub('{' + 'nucleus_portfolio_id' + '}', nucleus_portfolio_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BrokerageBalanceVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BrokerageApi#get_brokerage_balance_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get a Bank Link
    # @param nucleus_bank_link_id nucleus_bank_link_id
    # @param [Hash] opts the optional parameters
    # @return [BrokerageBankLinkVO]
    def get_brokerage_bank_link_using_get(nucleus_bank_link_id, opts = {})
      data, _status_code, _headers = get_brokerage_bank_link_using_get_with_http_info(nucleus_bank_link_id, opts)
      data
    end

    # Get a Bank Link
    # @param nucleus_bank_link_id nucleus_bank_link_id
    # @param [Hash] opts the optional parameters
    # @return [Array<(BrokerageBankLinkVO, Fixnum, Hash)>] BrokerageBankLinkVO data, response status code and response headers
    def get_brokerage_bank_link_using_get_with_http_info(nucleus_bank_link_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BrokerageApi.get_brokerage_bank_link_using_get ...'
      end
      # verify the required parameter 'nucleus_bank_link_id' is set
      if @api_client.config.client_side_validation && nucleus_bank_link_id.nil?
        fail ArgumentError, "Missing the required parameter 'nucleus_bank_link_id' when calling BrokerageApi.get_brokerage_bank_link_using_get"
      end
      # resource path
      local_var_path = '/brokerage/bank_link/{nucleus_bank_link_id}'.sub('{' + 'nucleus_bank_link_id' + '}', nucleus_bank_link_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BrokerageBankLinkVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BrokerageApi#get_brokerage_bank_link_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get a Brokerage document
    # @param nucleus_document_id nucleus_document_id
    # @param [Hash] opts the optional parameters
    # @return [BrokerageDocumentVO]
    def get_brokerage_document_using_get(nucleus_document_id, opts = {})
      data, _status_code, _headers = get_brokerage_document_using_get_with_http_info(nucleus_document_id, opts)
      data
    end

    # Get a Brokerage document
    # @param nucleus_document_id nucleus_document_id
    # @param [Hash] opts the optional parameters
    # @return [Array<(BrokerageDocumentVO, Fixnum, Hash)>] BrokerageDocumentVO data, response status code and response headers
    def get_brokerage_document_using_get_with_http_info(nucleus_document_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BrokerageApi.get_brokerage_document_using_get ...'
      end
      # verify the required parameter 'nucleus_document_id' is set
      if @api_client.config.client_side_validation && nucleus_document_id.nil?
        fail ArgumentError, "Missing the required parameter 'nucleus_document_id' when calling BrokerageApi.get_brokerage_document_using_get"
      end
      # resource path
      local_var_path = '/brokerage/document/{nucleus_document_id}'.sub('{' + 'nucleus_document_id' + '}', nucleus_document_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BrokerageDocumentVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BrokerageApi#get_brokerage_document_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get portfolio holding performance
    # @param nucleus_portfolio_id nucleus_portfolio_id
    # @param [Hash] opts the optional parameters
    # @return [BrokeragePerformanceVO]
    def get_brokerage_holding_performance_using_get(nucleus_portfolio_id, opts = {})
      data, _status_code, _headers = get_brokerage_holding_performance_using_get_with_http_info(nucleus_portfolio_id, opts)
      data
    end

    # Get portfolio holding performance
    # @param nucleus_portfolio_id nucleus_portfolio_id
    # @param [Hash] opts the optional parameters
    # @return [Array<(BrokeragePerformanceVO, Fixnum, Hash)>] BrokeragePerformanceVO data, response status code and response headers
    def get_brokerage_holding_performance_using_get_with_http_info(nucleus_portfolio_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BrokerageApi.get_brokerage_holding_performance_using_get ...'
      end
      # verify the required parameter 'nucleus_portfolio_id' is set
      if @api_client.config.client_side_validation && nucleus_portfolio_id.nil?
        fail ArgumentError, "Missing the required parameter 'nucleus_portfolio_id' when calling BrokerageApi.get_brokerage_holding_performance_using_get"
      end
      # resource path
      local_var_path = '/brokerage/holding/performance/{nucleus_portfolio_id}'.sub('{' + 'nucleus_portfolio_id' + '}', nucleus_portfolio_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BrokeragePerformanceVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BrokerageApi#get_brokerage_holding_performance_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get portfolio holdings
    # @param nucleus_portfolio_id nucleus_portfolio_id
    # @param [Hash] opts the optional parameters
    # @return [BrokerageHoldingVO]
    def get_brokerage_holding_using_get(nucleus_portfolio_id, opts = {})
      data, _status_code, _headers = get_brokerage_holding_using_get_with_http_info(nucleus_portfolio_id, opts)
      data
    end

    # Get portfolio holdings
    # @param nucleus_portfolio_id nucleus_portfolio_id
    # @param [Hash] opts the optional parameters
    # @return [Array<(BrokerageHoldingVO, Fixnum, Hash)>] BrokerageHoldingVO data, response status code and response headers
    def get_brokerage_holding_using_get_with_http_info(nucleus_portfolio_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BrokerageApi.get_brokerage_holding_using_get ...'
      end
      # verify the required parameter 'nucleus_portfolio_id' is set
      if @api_client.config.client_side_validation && nucleus_portfolio_id.nil?
        fail ArgumentError, "Missing the required parameter 'nucleus_portfolio_id' when calling BrokerageApi.get_brokerage_holding_using_get"
      end
      # resource path
      local_var_path = '/brokerage/holding/{nucleus_portfolio_id}'.sub('{' + 'nucleus_portfolio_id' + '}', nucleus_portfolio_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BrokerageHoldingVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BrokerageApi#get_brokerage_holding_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get an Order
    # @param nucleus_order_id nucleus_order_id
    # @param [Hash] opts the optional parameters
    # @return [BrokerageOrderVO]
    def get_brokerage_order_using_get(nucleus_order_id, opts = {})
      data, _status_code, _headers = get_brokerage_order_using_get_with_http_info(nucleus_order_id, opts)
      data
    end

    # Get an Order
    # @param nucleus_order_id nucleus_order_id
    # @param [Hash] opts the optional parameters
    # @return [Array<(BrokerageOrderVO, Fixnum, Hash)>] BrokerageOrderVO data, response status code and response headers
    def get_brokerage_order_using_get_with_http_info(nucleus_order_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BrokerageApi.get_brokerage_order_using_get ...'
      end
      # verify the required parameter 'nucleus_order_id' is set
      if @api_client.config.client_side_validation && nucleus_order_id.nil?
        fail ArgumentError, "Missing the required parameter 'nucleus_order_id' when calling BrokerageApi.get_brokerage_order_using_get"
      end
      # resource path
      local_var_path = '/brokerage/order/{nucleus_order_id}'.sub('{' + 'nucleus_order_id' + '}', nucleus_order_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BrokerageOrderVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BrokerageApi#get_brokerage_order_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get securities information
    # @param vendor_name vendor_name
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :get_fundamentals get_fundamentals (default to false)
    # @option opts [String] :nucleus_security_id nucleus_security_id
    # @return [BrokerageSecuritiesVO]
    def get_brokerage_securities_using_get(vendor_name, opts = {})
      data, _status_code, _headers = get_brokerage_securities_using_get_with_http_info(vendor_name, opts)
      data
    end

    # Get securities information
    # @param vendor_name vendor_name
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :get_fundamentals get_fundamentals
    # @option opts [String] :nucleus_security_id nucleus_security_id
    # @return [Array<(BrokerageSecuritiesVO, Fixnum, Hash)>] BrokerageSecuritiesVO data, response status code and response headers
    def get_brokerage_securities_using_get_with_http_info(vendor_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BrokerageApi.get_brokerage_securities_using_get ...'
      end
      # verify the required parameter 'vendor_name' is set
      if @api_client.config.client_side_validation && vendor_name.nil?
        fail ArgumentError, "Missing the required parameter 'vendor_name' when calling BrokerageApi.get_brokerage_securities_using_get"
      end
      # resource path
      local_var_path = '/brokerage/securities'

      # query parameters
      query_params = {}
      query_params[:'vendor_name'] = vendor_name
      query_params[:'get_fundamentals'] = opts[:'get_fundamentals'] if !opts[:'get_fundamentals'].nil?
      query_params[:'nucleus_security_id'] = opts[:'nucleus_security_id'] if !opts[:'nucleus_security_id'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BrokerageSecuritiesVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BrokerageApi#get_brokerage_securities_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get account transactions
    # @param drivewealth_response drivewealthResponse
    # @param end_date end_date
    # @param nucleus_portfolio_id nucleus_portfolio_id
    # @param start_date start_date
    # @param [Hash] opts the optional parameters
    # @return [BrokerageTransactionVO]
    def get_brokerage_transactions_using_get(drivewealth_response, end_date, nucleus_portfolio_id, start_date, opts = {})
      data, _status_code, _headers = get_brokerage_transactions_using_get_with_http_info(drivewealth_response, end_date, nucleus_portfolio_id, start_date, opts)
      data
    end

    # Get account transactions
    # @param drivewealth_response drivewealthResponse
    # @param end_date end_date
    # @param nucleus_portfolio_id nucleus_portfolio_id
    # @param start_date start_date
    # @param [Hash] opts the optional parameters
    # @return [Array<(BrokerageTransactionVO, Fixnum, Hash)>] BrokerageTransactionVO data, response status code and response headers
    def get_brokerage_transactions_using_get_with_http_info(drivewealth_response, end_date, nucleus_portfolio_id, start_date, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BrokerageApi.get_brokerage_transactions_using_get ...'
      end
      # verify the required parameter 'drivewealth_response' is set
      if @api_client.config.client_side_validation && drivewealth_response.nil?
        fail ArgumentError, "Missing the required parameter 'drivewealth_response' when calling BrokerageApi.get_brokerage_transactions_using_get"
      end
      # verify the required parameter 'end_date' is set
      if @api_client.config.client_side_validation && end_date.nil?
        fail ArgumentError, "Missing the required parameter 'end_date' when calling BrokerageApi.get_brokerage_transactions_using_get"
      end
      # verify the required parameter 'nucleus_portfolio_id' is set
      if @api_client.config.client_side_validation && nucleus_portfolio_id.nil?
        fail ArgumentError, "Missing the required parameter 'nucleus_portfolio_id' when calling BrokerageApi.get_brokerage_transactions_using_get"
      end
      # verify the required parameter 'start_date' is set
      if @api_client.config.client_side_validation && start_date.nil?
        fail ArgumentError, "Missing the required parameter 'start_date' when calling BrokerageApi.get_brokerage_transactions_using_get"
      end
      # resource path
      local_var_path = '/brokerage/transaction/{nucleus_portfolio_id}'.sub('{' + 'nucleus_portfolio_id' + '}', nucleus_portfolio_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'end_date'] = end_date
      query_params[:'start_date'] = start_date

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(drivewealth_response)
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BrokerageTransactionVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BrokerageApi#get_brokerage_transactions_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update a Bank Link
    # @param nucleus_bank_link_id nucleus_bank_link_id
    # @param [Hash] opts the optional parameters
    # @return [BrokerageBankLinkVO]
    def update_brokerage_bank_link_using_put(nucleus_bank_link_id, opts = {})
      data, _status_code, _headers = update_brokerage_bank_link_using_put_with_http_info(nucleus_bank_link_id, opts)
      data
    end

    # Update a Bank Link
    # @param nucleus_bank_link_id nucleus_bank_link_id
    # @param [Hash] opts the optional parameters
    # @return [Array<(BrokerageBankLinkVO, Fixnum, Hash)>] BrokerageBankLinkVO data, response status code and response headers
    def update_brokerage_bank_link_using_put_with_http_info(nucleus_bank_link_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BrokerageApi.update_brokerage_bank_link_using_put ...'
      end
      # verify the required parameter 'nucleus_bank_link_id' is set
      if @api_client.config.client_side_validation && nucleus_bank_link_id.nil?
        fail ArgumentError, "Missing the required parameter 'nucleus_bank_link_id' when calling BrokerageApi.update_brokerage_bank_link_using_put"
      end
      # resource path
      local_var_path = '/brokerage/bank_link/{nucleus_bank_link_id}'.sub('{' + 'nucleus_bank_link_id' + '}', nucleus_bank_link_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BrokerageBankLinkVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BrokerageApi#update_brokerage_bank_link_using_put\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update a Brokerage client
    # @param nucleus_client_id nucleus_client_id
    # @param [Hash] opts the optional parameters
    # @option opts [BrokerageUpdateClientCO] :client_co clientCO
    # @return [BrokerageUpdateClientVO]
    def update_brokerage_client_using_put(nucleus_client_id, opts = {})
      data, _status_code, _headers = update_brokerage_client_using_put_with_http_info(nucleus_client_id, opts)
      data
    end

    # Update a Brokerage client
    # @param nucleus_client_id nucleus_client_id
    # @param [Hash] opts the optional parameters
    # @option opts [BrokerageUpdateClientCO] :client_co clientCO
    # @return [Array<(BrokerageUpdateClientVO, Fixnum, Hash)>] BrokerageUpdateClientVO data, response status code and response headers
    def update_brokerage_client_using_put_with_http_info(nucleus_client_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: BrokerageApi.update_brokerage_client_using_put ...'
      end
      # verify the required parameter 'nucleus_client_id' is set
      if @api_client.config.client_side_validation && nucleus_client_id.nil?
        fail ArgumentError, "Missing the required parameter 'nucleus_client_id' when calling BrokerageApi.update_brokerage_client_using_put"
      end
      # resource path
      local_var_path = '/brokerage/client/{nucleus_client_id}'.sub('{' + 'nucleus_client_id' + '}', nucleus_client_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(opts[:'client_co'])
      auth_names = ['oauth2']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'BrokerageUpdateClientVO')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: BrokerageApi#update_brokerage_client_using_put\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
